summaryrefslogtreecommitdiffstats
path: root/scripts/mimetype
diff options
context:
space:
mode:
Diffstat (limited to 'scripts/mimetype')
-rwxr-xr-xscripts/mimetype38
1 files changed, 38 insertions, 0 deletions
diff --git a/scripts/mimetype b/scripts/mimetype
new file mode 100755
index 000000000..3c0c17e9b
--- /dev/null
+++ b/scripts/mimetype
@@ -0,0 +1,38 @@
+#!/usr/bin/perl
+use warnings;
+use strict;
+use File::MimeInfo::Magic qw(mimetype globs);
+
+exit 1 unless @ARGV == 2;
+
+my $filename = $ARGV[0];
+my $file = $ARGV[1];
+my $type = "";
+my $file_type = "";
+
+exit 1 unless -f $file;
+
+$type = globs($filename);
+
+# globbing takes priority over all other
+if (!$type) {
+ $type = mimetype($file);
+ if ($type eq "application/octet-stream") {
+ # application/octet-stream normally means the detection failed
+ # use the output of file in this case
+ $file_type = `file -b --mime-type $file`;
+ chomp $file_type;
+ $type = $file_type;
+ if ($type eq "text/plain") {
+ # detect ascii with color codes
+ $file_type = `file -b $file`;
+ chomp $file_type;
+ if ($file_type eq "ASCII text, with escape sequences") {
+ $type = "text/plain-ascii";
+ }
+ }
+ }
+}
+
+print "$type\n";
+